/* Header file for the stack abstract data type (stack.h) */
#ifndef STACK_H
#define STACK_H 

struct stack_t;

typedef struct stack_t *stack;

/* create an empty stack */
extern stack stack_create(void);

/* destroy a stack s */
extern void stack_destroy(stack s);

/* return true if and only if the stack s is empty */
extern int stack_empty(stack s);

/* push an object on a stack s */
extern void stack_push(stack s, void *object);

/* pop an element off of a non-empty stack s */
extern void stack_pop(stack s);

/* return the k-th top element of a stack s containing at least k
   elements */
extern void * stack_get(stack s, int k);

#endif
